function [ perm, cost ] = LAP( C  )
% LAP Solves for the optimal permutation in the cost matrix C. 
% The outputs are a n-vector perm such that if P is the optimal permutation
% matrix P*[1:n] = perm. cost is the cost for this permutation in C.

[n,~] = size(C);

% Auction
%integerize  costmatrix 
D = 1e7*C;
% Auction expects a benefit matrix
perm = assignmentProblemAuctionAlgorithm(-D);

cost = sum(C(sub2ind([n n],1:n,perm')));


end

