function [ H ] = curvature_histogram( I, gauss, nbins )
%CURVATURE_HISTOGRAM Summary of this function goes here
%   Detailed explanation goes here

% mask for contour
C = extract_contour(I, 2);

% filter with gauss kernel
if gauss > 0
    I = imgaussfilt(I, gauss);
end

% normalized gradient
G = grad_fe(I);
G = G ./ repmat(sqrt(sum(G.^2,3)+1e-10), 1, 1, 2);
G(isnan(G)) = 0;

% divergence
D = divergence(G(:,:,1), G(:,:,2));

% divergence on contour
curvatures = D(C);

% histogram with nbins number of bins of curvatures
h = histogram(curvatures(:), nbins);
H = h.Values;

end

