%% Exercise 3, Sheet 3
%% LOAD IMAGES

I1 = double(imread('MPEG7/bat-9.gif'));
I2 = double(imread('MPEG7/device7-1.gif'));
I3 = double(imread('MPEG7/turtle-1.gif'));

% extract contour

C1 = extract_contour(I1, 2);
C2 = extract_contour(I2, 2);
C3 = extract_contour(I3, 2);

% gaussian

gaussian = 2;

I1 = imgaussfilt(I1, gaussian);
I2 = imgaussfilt(I2, gaussian);
I3 = imgaussfilt(I3, gaussian);

%% CURVATURE

% gradient

G1 = grad_fe(I1);
G2 = grad_fe(I2);
G3 = grad_fe(I3);

% normalize gradient

G1 = G1 ./ repmat(sqrt(sum(G1.^2,3)+1e-10), 1, 1, 2);
G1(isnan(G1)) = 0;
G2 = G2 ./ repmat(sqrt(sum(G2.^2,3)), 1, 1, 2);
G2(isnan(G2)) = 0;
G3 = G3 ./ repmat(sqrt(sum(G3.^2,3)), 1, 1, 2);
G3(isnan(G3)) = 0;

% divergence

D1 = divergence(G1(:,:,1), G1(:,:,2));
D2 = divergence(G2(:,:,1), G2(:,:,2));
D3 = divergence(G3(:,:,1), G3(:,:,2));

%% VISUALIZE

% gradient

figure,

subplot(3,3,1), imagesc(I1), title('bat-9'),
subplot(3,3,2), imagesc(G1(:,:,1)), title('gradient x-direction'),
subplot(3,3,3), imagesc(G1(:,:,2)), title('gradient y-direction'),

subplot(3,3,4), imagesc(I2), title('device7-1'),
subplot(3,3,5), imagesc(G2(:,:,1)), title('gradient x-direction'),
subplot(3,3,6), imagesc(G2(:,:,2)), title('gradient y-direction'),

subplot(3,3,7), imagesc(I3), title('turtle-1'),
subplot(3,3,8), imagesc(G3(:,:,1)), title('gradient x-direction'),
subplot(3,3,9), imagesc(G3(:,:,2)), title('gradient y-direction'),

% curvature

figure,

% The Ps are only for visualisation
P1 = NaN(size(D1));
P2 = NaN(size(D2));
P3 = NaN(size(D3));
P1(C1) = D1(C1);
P2(C2) = D2(C2);
P3(C3) = D3(C3);

subplot(2,3,1), imagesc(I1),
subplot(2,3,4), imagesc(P1), set(gca, 'CLim', [-1, 1]),

subplot(2,3,2), imagesc(I2),
subplot(2,3,5), imagesc(P2), set(gca, 'CLim', [-1, 1]),

subplot(2,3,3), imagesc(I3),
subplot(2,3,6), imagesc(P3), set(gca, 'CLim', [-1, 1]),

colormap(jet);
