%% Exercise 4, Sheet 3
%% load all images

imgPath = './MPEG7/';
imgType = '*.gif'; 
images  = dir([imgPath imgType]);
Seq = cell(1, length(images));
for idx = 1:length(images)
    Seq{idx} = double(imread([imgPath images(idx).name]));
end

%% load reference device7-1

ref = double(imread(strcat(imgPath, 'device7-1.gif')));

%% calculate descriptors

nbins = 20; % number of bins in histogram
gauss = 1;

histograms = cell(size(Seq));

% on all images
for i=1:length(Seq)
   histograms{i} = curvature_histogram(Seq{i}, gauss, nbins);
   histograms{i} = histograms{i} ./ norm(histograms{i},2);
end

% on reference

ref_histogram = curvature_histogram(ref, gauss, nbins);
ref_histogram = ref_histogram ./ norm(ref_histogram,2);

%% rank images wrt to reference

distances = zeros(size(histograms));
for i=1:length(histograms)
   distances(i) = norm(histograms{i} - ref_histogram, 2);
end

[sorted, ids] = sort(distances);

figure,
columns = ceil(length(ids)/2)+1;
subplot(2,columns,1), imagesc(ref), axis equal, title('Reference'),

for i=1:length(ids)
   
    subplot(2,columns,1+i), imagesc(Seq{ids(i)}), title(sprintf('dist: %.3f', sorted(i))), axis equal,
    
end
