function [ C ] = extract_contour( I, thickness )
%EXTRACT_CONTOUR Extract a contour with given thickness from a binary
% image as a binary mask on the image. There is no guarantee on the
% connectivity of the contour.

I = (I>mean(unique(I)));
I = bwdist(I)-bwdist(~I);

C = abs(I)<thickness;

end

