function [ ] = visualise_matching( S1, S2, P )
%VISUALISE_MATCHING Takes two pointwise contours and colors their 
% correspondence according to P. S1, S2 should be a 2 x n matrix and
% P such that S1(:,P) = S2.

n = size(S1,2);

figure,
cm = jet(n);
subplot(1,2,1),
scatter(S1(1,:), -S1(2,:), 20*ones(n,1), cm, 'filled'), axis equal,

subplot(1,2,2),
scatter(S2(1,:), -S2(2,:), 20*ones(n,1), cm(P,:), 'filled'), axis equal,

end

